﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls;

namespace DataChartZoomBarSync
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly List<RangeItem> _rangeList = new List<RangeItem>();
        private List<TimeItem> _timeValues = new List<TimeItem>();
        public static bool SelectionChanged { get; set; }
        public static int Count { get; set; }
        public static int SelectedIndex { get; set; }
        public static bool DrawHighResReport { get; set; }
        public MainWindow()
        {
            InitializeComponent();
             UpdateTimeList();
             filterText.ItemsSource = _timeValues;
             filterText.DataContext = _timeValues;
        }

        void asd_MouseDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
        }
        private void FilterText_OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            TimeItem itemTemp = (TimeItem)this.filterText.SelectedItem;
            SelectionChanged = true;
            //plusButton.IsEnabled = itemTemp.Time != 0;
            //minusButton.IsEnabled = itemTemp.Time != 30;
            //Mouse.OverrideCursor = Cursors.Wait;
            //DevExpress.XtraSplashScreen.SplashScreenManager.ShowForm(typeof(WaitFormMain));
            //bool done = HighResDataDisplay.FilterText(itemTemp.Time);
            //Keyboard.Focus(HighResDataDisplay.highResView.scroller);
            FilterText(itemTemp.Time);

        }
        private double percentage { get; set; }
        public bool FilterText(int filter)
        {


            if (filter == 15)
            {


                xmZoombar.Range = new Range { Minimum = .01, Maximum = .02 };




            }

            if (filter == 30)
            {


                xmZoombar.Range = new Range { Minimum = .01, Maximum = .030 };




            }
            if (filter == 0)
            {
                xmZoombar.SmallChange = .1;
                xmZoombar.Range = new Range { Minimum = 0, Maximum = 1 };
            }

            return true;
        }
        private void zoombar1_KeyDown_1(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Right && xmZoombar.Range.Maximum <= xmZoombar.Maximum - 10)
            {
                xmZoombar.Range.Maximum = xmZoombar.Range.Maximum + 10;
                xmZoombar.Range.Minimum = xmZoombar.Range.Minimum + 10;
            }
            if (e.Key == Key.Left && xmZoombar.Range.Minimum >= xmZoombar.Minimum + 10)
            {
                xmZoombar.Range.Maximum = xmZoombar.Range.Maximum - 10;
                xmZoombar.Range.Minimum = xmZoombar.Range.Minimum - 10;
            }
        }

        public bool IsZoombarChanging;

        private void xmDataChart_WindowRectChanged(object sender, Infragistics.RectChangedEventArgs e)
        {
            if (IsZoombarChanging) return;
            try
            {
                IsZoombarChanging = true;
                Range newZoombarRange = new Range
                {
                    Minimum = e.NewRect.X,
                    Maximum = e.NewRect.X + e.NewRect.Width
                };
                if (this.xmZoombar != null)
                {
                    this.xmZoombar.Range = newZoombarRange;
                    this.xmZoombar.Range.Minimum = 0;
                }
            }
            finally
            {
                IsZoombarChanging = false;
            }
        }

        private void xmZoombar_ZoomChanging(object sender, ZoomChangeEventArgs e)
        {
            if (this.xmDataChart == null) return;
            if (IsZoombarChanging) return;
            try
            {
                IsZoombarChanging = true;
         
                Range zoombarRange = e.NewRange; 
                this.xmDataChart.WindowRect = new Rect
                {
                    Y = 0,
                    Height = 1,
                    X = zoombarRange.Minimum,
                    Width = (e.NewRange.Maximum - zoombarRange.Minimum)
                };
            }
            finally
            {
                IsZoombarChanging = false;
            }
            
        }
        public class TimeItem
        {
            public TimeItem(int seconds, string display)
            {
                Time = seconds;
                Display = display;
            }

            public int Time;
            public string Display;
            public override string ToString()
            {
                return Display;
            }
        }
        private void UpdateTimeList()
        {
            Count = 0;
      
        
            TimeItem timeAll = new TimeItem(0, "All");
            _timeValues.Add(timeAll);
            Count++;
       
        
                TimeItem time1 = new TimeItem(30, "30 Seconds");
                _timeValues.Add(time1);
                Count++;

                TimeItem time = new TimeItem(15, "15 Seconds");
                _timeValues.Add(time);
                Count++;

            filterText.SelectedIndex = 0;
           
        }
        public class RangeItem
        {
            public RangeItem(TimeRange timerange)
            {
                Timerange = timerange;
            }

            public TimeRange Timerange;

            public override string ToString()
            {
                return Timerange.Min.ToString() + " - " + Timerange.Max.ToString();
            }
        }
        public struct TimeRange
        {
            /// <summary>
            ///     Max time range
            /// </summary>
            public DateTime Max { get; set; }

            /// <summary>
            ///     Min time range
            /// </summary>
            public DateTime Min { get; set; }

            /// <summary>
            ///     Session Id
            /// </summary>
            public Guid Id { get; set; }
        }

        private void XmZoombar_OnZoomChanged(object sender, ZoomChangedEventArgs e)
        {
            check.Content = (xmZoombar.Range.Maximum - xmZoombar.Range.Minimum).ToString();
        }

        
    }
}
